Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/physiq_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/physiq_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/physiq_mod.F90	(revision 4727)
@@ -76,13 +76,21 @@
     USE vampir
     USE write_field_phy
-#ifdef CPP_XIOS
     USE wxios, ONLY: g_ctx, wxios_set_context
-#endif
-    USE atke_turbulence_ini_mod, ONLY : atke_ini
-    USE lscp_ini_mod, ONLY : lscp_ini
-    USE lscp_mod, ONLY : lscp
-    USE wake_ini_mod, ONLY : wake_ini
+    USE lmdz_lscp, ONLY : lscp
+    USE lmdz_call_cloud_optics_prop, ONLY : call_cloud_optics_prop
+    USE lmdz_lscp_old, ONLY : fisrtilp
+    USE lmdz_call_blowing_snow, ONLY : call_blowing_snow_sublim_sedim
+    USE lmdz_wake_ini, ONLY : wake_ini
     USE yamada_ini_mod, ONLY : yamada_ini
-    USE thermcell_ini_mod, ONLY : thermcell_ini
+    USE lmdz_atke_turbulence_ini, ONLY : atke_ini
+    USE lmdz_thermcell_ini, ONLY : thermcell_ini, iflag_thermals_tenv
+    USE lmdz_thermcell_dtke, ONLY : thermcell_dtke
+    USE lmdz_blowing_snow_ini, ONLY : blowing_snow_ini , qbst_bs 
+    USE lmdz_lscp_ini, ONLY : lscp_ini
+    USE lmdz_ratqs_main, ONLY : ratqs_main
+    USE lmdz_ratqs_ini, ONLY : ratqs_ini
+    USE lmdz_cloud_optics_prop_ini, ONLY : cloud_optics_prop_ini
+    USE phys_output_var_mod, ONLY :      cloudth_sth,cloudth_senv,cloudth_sigmath,cloudth_sigmaenv
+
 
     !USE cmp_seri_mod
@@ -124,14 +132,15 @@
 
 #ifdef CPP_StratAer
-    USE strataer_mod, ONLY: strataer_init
-#endif
-
-
-#ifdef CPP_XIOS
-    USE xios, ONLY: xios_update_calendar, xios_context_finalize
-    USE xios, ONLY: xios_get_field_attr, xios_field_is_active, xios_context
-    USE xios, ONLY: xios_set_current_context
-    USE wxios, ONLY: missing_val, missing_val_omp
-#endif
+    USE strataer_local_var_mod
+    USE strataer_nuc_mod, ONLY: strataer_nuc_init
+    USE strataer_emiss_mod, ONLY: strataer_emiss_init
+#endif
+
+
+    USE lmdz_xios, ONLY: xios_update_calendar, xios_context_finalize
+    USE lmdz_xios, ONLY: xios_get_field_attr, xios_field_is_active, xios_context
+    USE lmdz_xios, ONLY: xios_set_current_context
+    USE wxios, ONLY: missing_val_xios => missing_val, using_xios
+
 #ifndef CPP_XIOS
     USE paramLMDZ_phy_mod
@@ -157,5 +166,5 @@
         & iso_verif_aberrant_choix,iso_verif_positif, &
         & iso_verif_positif_choix_vect,iso_verif_o18_aberrant_nostop, &
-        & iso_verif_init,&
+        & iso_verif_init,iso_verif_aberrant_enc_choix_nostop,&
         & iso_verif_positif_strict_nostop,iso_verif_O18_aberrant_enc_vect2D
 #endif
@@ -183,8 +192,8 @@
        ! [Variables internes non sauvegardees de la physique]
        ! Variables locales pour effectuer les appels en serie
-       t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,tr_seri,rneb_seri, &
+       t_seri,q_seri,ql_seri,qs_seri,qbs_seri,u_seri,v_seri,tr_seri,rneb_seri, &
        ! Dynamic tendencies (diagnostics)
-       d_t_dyn,d_q_dyn,d_ql_dyn,d_qs_dyn,d_u_dyn,d_v_dyn,d_tr_dyn,d_rneb_dyn, &
-       d_q_dyn2d,d_ql_dyn2d,d_qs_dyn2d, &
+       d_t_dyn,d_q_dyn,d_ql_dyn,d_qs_dyn,d_qbs_dyn,d_u_dyn,d_v_dyn,d_tr_dyn,d_rneb_dyn, &
+       d_q_dyn2d,d_ql_dyn2d,d_qs_dyn2d,d_qbs_dyn2d, &
        ! Physic tendencies
        d_t_con,d_q_con,d_u_con,d_v_con, &
@@ -203,8 +212,10 @@
        plul_st,plul_th, &
        !
-       d_t_vdf,d_q_vdf,d_u_vdf,d_v_vdf,d_t_diss, &
+       d_t_vdf,d_q_vdf, d_qbs_vdf, d_u_vdf,d_v_vdf,d_t_diss, &
        d_t_vdf_x, d_t_vdf_w, &
        d_q_vdf_x, d_q_vdf_w, &
        d_ts, &
+       !
+       d_t_bs,d_q_bs,d_qbs_bs, &
        !
 !       d_t_oli,d_u_oli,d_v_oli, &
@@ -254,6 +265,6 @@
        cldh, cldl,cldm, cldq, cldt,      &
        JrNt,                             &
-       dthmin, evap, fder, plcl, plfc,   &
-       prw, prlw, prsw,                  &
+       dthmin, evap, snowerosion,fder, plcl, plfc,   &
+       prw, prlw, prsw, prbsw,                  &
        s_lcl, s_pblh, s_pblt, s_therm,   &
        cdragm, cdragh,                   &
@@ -328,4 +339,6 @@
        !
        rneblsvol, &
+       pfraclr,pfracld, &
+       distcltop,temp_cltop, &
        zqsatl, zqsats, &
        qclr, qcld, qss, qvc, rnebclr, rnebss, gamma_ss, &
@@ -343,5 +356,5 @@
        fsolsw, wfbils, wfbilo,  &
        wfevap, wfrain, wfsnow,  &  
-       prfl, psfl, fraca, Vprecip,  &
+       prfl, psfl,bsfl, fraca, Vprecip,  &
        zw2,  &
        !
@@ -355,5 +368,6 @@
        beta_prec,  &
        rneb,  &
-       zxsnow,snowhgt,qsnow,to_ice,sissnow,runoff,albsol3_lic
+       zxsnow,snowhgt,qsnow,to_ice,sissnow,runoff,albsol3_lic, &
+       zxfluxt,zxfluxq
 
 
@@ -384,4 +398,8 @@
 #endif
        !
+       USE phys_local_var_mod, ONLY: zfice, dNovrN, ptconv
+       USE phys_output_var_mod, ONLY: scdnc, cldncl, reffclwtop, lcc, reffclws, &
+       reffclwc, cldnvi, lcc3d, lcc3dcon, lcc3dstra, icc3dcon, icc3dstra
+
 
     IMPLICIT NONE
@@ -510,7 +528,7 @@
     SAVE seuil_inversion
     !$OMP THREADPRIVATE(seuil_inversion)
-    INTEGER iflag_ratqs
-    SAVE iflag_ratqs
-    !$OMP THREADPRIVATE(iflag_ratqs)
+    
+    
+    
     real facteur
 
@@ -526,7 +544,7 @@
     !======================================================================
     !
-    ! indices de traceurs eau vapeur, liquide, glace, fraction nuageuse LS (optional)
-    INTEGER,SAVE :: ivap, iliq, isol, irneb
-!$OMP THREADPRIVATE(ivap, iliq, isol, irneb)
+    ! indices de traceurs eau vapeur, liquide, glace, fraction nuageuse LS (optional), blowing snow (optional)
+    INTEGER,SAVE :: ivap, iliq, isol, irneb, ibs
+!$OMP THREADPRIVATE(ivap, iliq, isol, irneb, ibs)
     !
     !
@@ -593,4 +611,5 @@
     !
     !
+    include "radepsi.h"
     include "radopt.h"
     !
@@ -875,5 +894,4 @@
     !KE43
     EXTERNAL conema3  ! convect4.3
-    EXTERNAL fisrtilp  ! schema de condensation a grande echelle (pluie)
     !AA 
     ! JBM (3/14) fisrtilp_tr not loaded
@@ -905,11 +923,13 @@
     REAL dialiq(klon,klev)  ! eau liquide nuageuse
     REAL diafra(klon,klev)  ! fraction nuageuse
-    REAL cldliq(klon,klev)  ! eau liquide nuageuse
+    REAL radocond(klon,klev)  ! eau condensee nuageuse
     !
     !XXX PB 
     REAL fluxq(klon,klev, nbsrf)   ! flux turbulent d'humidite
-    !
-    REAL zxfluxt(klon, klev)
-    REAL zxfluxq(klon, klev)
+    REAL fluxqbs(klon,klev, nbsrf)   ! flux turbulent de neige soufflee
+    !
+    !FC    REAL zxfluxt(klon, klev)
+    !FC    REAL zxfluxq(klon, klev)
+    REAL zxfluxqbs(klon,klev)
     REAL zxfluxu(klon, klev)
     REAL zxfluxv(klon, klev)
@@ -1009,5 +1029,5 @@
     !
     ! tendance nulles
-    REAL, dimension(klon,klev):: du0, dv0, dt0, dq0, dql0, dqi0
+    REAL, dimension(klon,klev):: du0, dv0, dt0, dq0, dql0, dqi0, dqbs0
 #ifdef ISO
     REAL, dimension(ntraciso,klon,klev):: dxt0, dxtl0, dxti0
@@ -1156,4 +1176,6 @@
     REAL ztsol(klon)
     REAL q2m(klon,nbsrf)  ! humidite a 2m
+    REAL fsnowerosion(klon,nbsrf) ! blowing snow flux at surface
+    REAL qbsfra  ! blowing snow fraction
 #ifdef ISO
     REAL d_xtw(ntraciso),d_xtl(ntraciso), d_xts(ntraciso)
@@ -1219,7 +1241,7 @@
     !     climatology and the daylight climatology
     INTEGER,SAVE :: ncid_climoz                ! NetCDF file identifier
-    REAL, POINTER, SAVE :: press_cen_climoz(:) ! Pressure levels
-    REAL, POINTER, SAVE :: press_edg_climoz(:) ! Edges of pressure intervals
-    REAL, POINTER, SAVE :: time_climoz(:)      ! Time vector
+    REAL, ALLOCATABLE, SAVE :: press_cen_climoz(:) ! Pressure levels
+    REAL, ALLOCATABLE, SAVE :: press_edg_climoz(:) ! Edges of pressure intervals
+    REAL, ALLOCATABLE, SAVE :: time_climoz(:)      ! Time vector
     CHARACTER(LEN=13), PARAMETER :: vars_climoz(2) &
                                   = ["tro3         ","tro3_daylight"]
@@ -1234,5 +1256,4 @@
     !IM 100106 BEG : pouvoir sortir les ctes de la physique
     include "conema3.h"
-    include "fisrtilp.h"
     include "nuage.h"
     include "compbl.h"
@@ -1312,6 +1333,13 @@
     real xtql1(ntraciso,klon),xtql2(ntraciso,klon),corrxtql(ntraciso)
 #endif
+    
+
+    REAL, dimension(klon,klev) :: t_env,q_env
+
+    REAL, dimension(klon) :: pr_et
+    REAL, dimension(klon) :: w_et, jlr_g_c, jlr_g_s
 
     REAL pi
+    INTEGER ieru
 
     pi = 4. * ATAN(1.)
@@ -1329,4 +1357,5 @@
     CALL update_time(pdtphys)
     phys_tstep=NINT(pdtphys)
+    IF (.NOT. using_xios) missing_val=nf90_fill_real
 #ifdef CPP_XIOS
 ! switch to XIOS LMDZ physics context 
@@ -1372,4 +1401,5 @@
        isol = strIdx(tracers(:)%name, addPhase('H2O', 's'))
        irneb= strIdx(tracers(:)%name, addPhase('H2O', 'r'))
+       ibs  = strIdx(tracers(:)%name, addPhase('H2O', 'b'))
        CALL init_etat0_limit_unstruct
        IF (.NOT. create_etat0_limit) CALL init_limit_read(days_elapsed)
@@ -1388,5 +1418,5 @@
             solarlong0,seuil_inversion, &
             fact_cldcon, facttemps,ok_newmicro,iflag_radia, &
-            iflag_cld_th,iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
+            iflag_cld_th,ratqsbas,ratqshaut,tau_ratqs, &
             ok_ade, ok_aie, ok_alw, ok_cdnc, ok_volcan, flag_volc_surfstrat, aerosol_couple, &
             chemistry_couple, flag_aerosol, flag_aerosol_strat, flag_aer_feedback, &
@@ -1403,4 +1433,6 @@
 #ifdef CPP_StratAer
        CALL strataer_init
+       CALL strataer_nuc_init
+       CALL strataer_emiss_init
 #endif
 
@@ -1421,5 +1453,5 @@
        ENDIF
 
-       IF (ok_ice_sursat.AND.(nqo.NE.4)) THEN
+       IF (ok_ice_sursat.AND.(nqo.LT.4)) THEN
           WRITE (lunout, *) ' ok_ice_sursat=y requires 4 H2O tracers ', &
                '(H2O_g, H2O_l, H2O_s, H2O_r) but nqo=', nqo, '. Might as well stop here.'
@@ -1440,4 +1472,14 @@
        ENDIF
 
+        IF (ok_bs) THEN
+          abort_message='blowing snow cannot be activated with water isotopes yet'
+          CALL abort_physic(modname,abort_message, 1)
+         IF ((ok_ice_sursat.AND.nqo .LT.5).OR.(.NOT.ok_ice_sursat.AND.nqo.LT.4)) THEN
+             WRITE (lunout, *) 'activation of blowing snow needs a specific H2O tracer', &
+                               'but nqo=', nqo
+             abort_message='see above'
+             CALL abort_physic(modname,abort_message, 1)
+         ENDIF
+        ENDIF
        Ncvpaseq1 = 0
        dnwd0=0.0
@@ -1578,4 +1620,5 @@
           piz_aero(:,:,:,:) = 0.
           cg_aero(:,:,:,:) = 0.
+          d_q_ch4(:,:) = 0.
 
           config_inca='none' ! default
@@ -1589,4 +1632,5 @@
        piz_aero(:,:,:,:) = 1.
        cg_aero(:,:,:,:)  = 0.
+       d_q_ch4(:,:) = 0.
 
        IF (aerosol_couple .AND. (config_inca /= "aero" &
@@ -1807,5 +1851,5 @@
 
 !       CALL create_climoz(read_climoz)
-      IF (.NOT. create_etat0_limit) CALL init_aero_fromfile(flag_aerosol)  !! initialise aero from file for XIOS interpolation (unstructured_grid)
+      IF (.NOT. create_etat0_limit) CALL init_aero_fromfile(flag_aerosol, aerosol_couple)  !! initialise aero from file for XIOS interpolation (unstructured_grid)
       IF (.NOT. create_etat0_limit) CALL init_readaerosolstrato(flag_aerosol_strat)  !! initialise aero strato from file for XIOS interpolation (unstructured_grid)
 
@@ -1887,11 +1931,32 @@
        CALL wake_ini(rg,rd,rv,prt_level)
        CALL yamada_ini(klon,lunout,prt_level)
-       CALL atke_ini(prt_level, lunout, RG, RD, RPI, RCPD)
+       CALL atke_ini(prt_level, lunout, RG, RD, RPI, RCPD, RV)
        CALL thermcell_ini(iflag_thermals,prt_level,tau_thermals,lunout, &
    &    RG,RD,RCPD,RKAPPA,RLVTT,RETV)
-       IF (ok_new_lscp) then
-           CALL lscp_ini(pdtphys,ok_ice_sursat)
-       endif
-
+       CALL ratqs_ini(klon,klev,iflag_thermals,lunout,nbsrf,is_lic,is_ter,RG,RV,RD,RCPD,RLSTT,RLVTT,RTT)
+       CALL lscp_ini(pdtphys,lunout,prt_level,ok_ice_sursat,iflag_ratqs,fl_cor_ebil,RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT,RD,RG)
+       CALL blowing_snow_ini(prt_level,lunout, &
+                             RCPD, RLSTT, RLVTT, RLMLT, &
+                             RVTMP2, RTT,RD,RG)
+       ! Test de coherence sur oc_cdnc utilisé uniquement par cloud_optics_prop
+       IF (ok_newmicro) then
+          IF (iflag_rrtm.EQ.1) THEN
+#ifdef CPP_RRTM
+             IF (ok_cdnc.AND.NRADLP.NE.3) THEN
+             abort_message='RRTM choix incoherent NRADLP doit etre egal a 3 ' &
+                  // 'pour ok_cdnc' 
+             CALL abort_physic(modname,abort_message,1)
+             ENDIF
+#else
+
+             abort_message='You should compile with -rrtm if running with '//'iflag_rrtm=1'
+             CALL abort_physic(modname,abort_message,1)
+#endif
+          ENDIF
+       ENDIF   
+       CALL cloud_optics_prop_ini(klon, prt_level, lunout, flag_aerosol, &
+                                  & ok_cdnc, bl95_b0, &
+                                  & bl95_b1, latitude_deg, rpi, rg, rd, &
+                                  & zepsec, novlp, iflag_ice_thermo, ok_new_lscp)
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
@@ -1919,8 +1984,8 @@
        CALL phys_output_write(itap, pdtphys, paprs, pphis,                    &
                               pplay, lmax_th, aerosol_couple,                 &
-                              ok_ade, ok_aie, ok_volcan, ivap, iliq, isol, ok_sync,&
+                              ok_ade, ok_aie, ok_volcan, ivap, iliq, isol, ibs,  ok_sync,&
                               ptconv, read_climoz, clevSTD,                   &
                               ptconvth, d_u, d_t, qx, d_qx, zmasse,           &
-                              flag_aerosol, flag_aerosol_strat, ok_cdnc)
+                              flag_aerosol, flag_aerosol_strat, ok_cdnc,t,u1,v1)
 #endif
 
@@ -2119,22 +2184,17 @@
        !=============================================================
 
-#ifdef CPP_XIOS
-       ! Get "missing_val" value from XML files (from temperature variable)
-       !$OMP MASTER
-       CALL xios_get_field_attr("temp",default_value=missing_val_omp)
-       !$OMP END MASTER
-       !$OMP BARRIER
-       missing_val=missing_val_omp
-#endif
-
-#ifdef CPP_XIOS 
+       IF (using_xios) THEN    
+         ! Get "missing_val" value from XML files (from temperature variable)
+         IF (is_omp_master) CALL xios_get_field_attr("temp",default_value=missing_val)
+         CALL bcast_omp(missing_val)
+       ENDIF
+
+      IF (using_xios) THEN 
 ! Need to put this initialisation after phyetat0 as in the coupled model the XIOS context is only
 ! initialised at that moment
        ! Get "missing_val" value from XML files (from temperature variable)
-       !$OMP MASTER
-       CALL xios_get_field_attr("temp",default_value=missing_val_omp)
-       !$OMP END MASTER
-       !$OMP BARRIER
-       missing_val=missing_val_omp
+        IF (is_omp_master) CALL xios_get_field_attr("temp",default_value=missing_val)
+        CALL bcast_omp(missing_val)
+       
        ! 
        ! Now we activate some double radiation call flags only if some
@@ -2177,5 +2237,7 @@
        CALL bcast(dryaod_diag)
        CALL bcast(ok_4xCO2atm)
-#endif 
+
+     ENDIF !using_xios 
+
        !
        CALL printflag( tabcntr0,radpas,ok_journe, &
@@ -2406,4 +2468,5 @@
     dql0(:,:)=0.
     dqi0(:,:)=0.
+    dqbs0(:,:)=0.
 #ifdef ISO
       dxt0(:,:,:)=0.
@@ -2463,4 +2526,5 @@
           q_seri(i,k)  = qx(i,k,ivap)
           ql_seri(i,k) = qx(i,k,iliq)
+          qbs_seri(i,k) = 0.
           !CR: ATTENTION, on rajoute la variable glace
           IF (nqo.EQ.2) THEN             !--vapour and liquid only
@@ -2470,8 +2534,16 @@
              qs_seri(i,k) = qx(i,k,isol)
              rneb_seri(i,k) = 0.
-          ELSE IF (nqo.EQ.4) THEN        !--vapour, liquid, ice and rneb
+          ELSE IF (nqo.GE.4) THEN        !--vapour, liquid, ice and rneb and blowing snow
              qs_seri(i,k) = qx(i,k,isol)
+             IF (ok_ice_sursat) THEN
              rneb_seri(i,k) = qx(i,k,irneb)
+             ENDIF
+             IF (ok_bs) THEN
+             qbs_seri(i,k)= qx(i,k,ibs)
+             ENDIF
+
           ENDIF
+
+
        ENDDO
     ENDDO
@@ -2480,5 +2552,6 @@
 #ifdef ISO
 #ifdef ISOVERIF
-!    write(*,*) 'physiq 1847: qx(1,1,:)=',qx(1,1,:)
+    write(*,*) 'physiq 1847: qx(1,1,:)=',qx(1,1,:)
+    write(*,*) 'iqIsoPha(:,ivap)=',iqIsoPha(:,ivap)
     write(*,*) 'physiq 1846b: ok_isotopes,ntraciso,niso=',niso>0,ntraciso,niso
 #endif
@@ -2514,5 +2587,5 @@
     qql1(:)=0.0
     DO k = 1, klev
-      qql1(:)=qql1(:)+(q_seri(:,k)+ql_seri(:,k)+qs_seri(:,k))*zmasse(:,k)
+      qql1(:)=qql1(:)+(q_seri(:,k)+ql_seri(:,k)+qs_seri(:,k)+qbs_seri(:,k))*zmasse(:,k)
     ENDDO
 #ifdef ISO
@@ -2596,5 +2669,5 @@
      &              'physiq 2099 ql').eq.1) then
                   write(*,*) 'i,k,ql_seri(i,k)=',i,k,ql_seri(i,k) 
-                  stop
+                  !stop
               endif !  if (iso_verif_o18_aberrant_nostop 
             endif !if (q_seri(i,k).gt.errmax) then  
@@ -2605,10 +2678,19 @@
      &              'physiq 2099 qs').eq.1) then
                   write(*,*) 'i,k,qs_seri(i,k)=',i,k,qs_seri(i,k) 
-                  stop
+                  !stop
               endif !  if (iso_verif_o18_aberrant_nostop 
             endif !if (q_seri(i,k).gt.errmax) then
           enddo !k=1,klev
          enddo  !i=1,klon
-        endif !if ((iso_HDO.gt.0).and.(iso_O18.gt.0)) then
+        endif !if ((iso_HDO.gt.0).and.(iso_O18.gt.0)) then         
+#ifdef ISOTRAC  
+         DO k = 1, klev
+           DO i = 1, klon    
+             call iso_verif_traceur(xt_seri(1,i,k),'physiq 2620a')
+             call iso_verif_traceur(xtl_seri(1,i,k),'physiq 2620b')
+             call iso_verif_traceur(xts_seri(1,i,k),'physiq 2620c') 
+           enddo
+         enddo
+#endif
 #endif
     !
@@ -2621,4 +2703,5 @@
        d_ql_dyn(:,:) = (ql_seri(:,:)-ql_ancien(:,:))/phys_tstep
        d_qs_dyn(:,:) = (qs_seri(:,:)-qs_ancien(:,:))/phys_tstep
+       d_qbs_dyn(:,:) = (qbs_seri(:,:)-qbs_ancien(:,:))/phys_tstep
        CALL water_int(klon,klev,q_seri,zmasse,zx_tmp_fi2d)
        d_q_dyn2d(:)=(zx_tmp_fi2d(:)-prw_ancien(:))/phys_tstep
@@ -2627,4 +2710,6 @@
        CALL water_int(klon,klev,qs_seri,zmasse,zx_tmp_fi2d)
        d_qs_dyn2d(:)=(zx_tmp_fi2d(:)-prsw_ancien(:))/phys_tstep
+       CALL water_int(klon,klev,qbs_seri,zmasse,zx_tmp_fi2d)
+       d_qbs_dyn2d(:)=(zx_tmp_fi2d(:)-prbsw_ancien(:))/phys_tstep
        ! !! RomP >>>   td dyn traceur
        IF (nqtot > nqo) d_tr_dyn(:,:,:)=(tr_seri(:,:,:)-tr_ancien(:,:,:))/phys_tstep
@@ -2713,4 +2798,5 @@
        d_ql_dyn2d(:) = 0.0
        d_qs_dyn2d(:) = 0.0
+       d_qbs_dyn2d(:)= 0.0
 
 #ifdef ISO
@@ -2736,4 +2822,5 @@
        ! !! RomP <<<
        d_rneb_dyn(:,:)=0.0
+       d_qbs_dyn(:,:)=0.0
        ancien_ok = .TRUE.
     ENDIF
@@ -2844,4 +2931,17 @@
        ENDIF
     ENDIF
+
+#ifdef ISO
+#ifdef ISOVERIF 
+#ifdef ISOTRAC 
+         DO k = 1, klev
+           DO i = 1, klon         
+             call iso_verif_traceur(xt_seri(1,i,k), &
+     &           'physiq 2856: avant reevp')
+           enddo
+         enddo
+#endif
+#endif
+#endif
     !
     ! Re-evaporer l'eau liquide nuageuse
@@ -2855,5 +2955,5 @@
 
      CALL add_phys_tend &
-            (du0,dv0,d_t_eva,d_q_eva,d_ql_eva,d_qi_eva,paprs,&
+            (du0,dv0,d_t_eva,d_q_eva,d_ql_eva,d_qi_eva,dqbs0,paprs,&
                'eva',abortphy,flag_inhib_tend,itap,0 &
 #ifdef ISO
@@ -3008,4 +3108,15 @@
        ELSE IF (iflag_gusts==2) THEN
           gustiness(1:klon)=f_gust_bl*ale_bl_stat(1:klon)+f_gust_wk*ale_wake(1:klon)
+       !!!! modif olivier torres
+       ELSE IF (iflag_gusts==3) THEN
+          w_et=wstar(1,3)
+          jlr_g_s=(0.65*w_et)**2
+          pr_et=rain_con*8640
+          jlr_g_c = (((19.8*(pr_et(1:klon)**2))/(1.5+pr_et(1:klon)+pr_et(1:klon)**2))**(0.4))**2
+          gustiness(1:klon)=jlr_g_c+jlr_g_s
+!!       write(*,*) "rain ",pr_et
+!!       write(*,*) "jlr_g_c",jlr_g_c
+!!       write(*,*) "wstar",wstar(1,3)
+!!       write(*,*) "jlr_g_s",jlr_g_s
           ! ELSE IF (iflag_gusts==2) THEN
           !    do i = 1, klon
@@ -3024,7 +3135,7 @@
             longitude_deg, latitude_deg, rugoro,  zrmu0,      &
             sollwdown,    cldt,      &
-            rain_fall, snow_fall, solsw,   solswfdiff, sollw,     &
+            rain_fall, snow_fall, bs_fall, solsw,   solswfdiff, sollw,     &
             gustiness,                                &
-            t_seri,    q_seri,    u_seri,  v_seri,    &
+            t_seri,    q_seri,   qbs_seri,  u_seri,  v_seri,    &
                                 !nrlmd+jyg<
             wake_deltat, wake_deltaq, wake_cstar, wake_s, &
@@ -3037,9 +3148,9 @@
                                 !albedo SB >>>
                                 ! albsol1,   albsol2,   sens,    evap,      &
-            albsol_dir,   albsol_dif,   sens,    evap,   &  
+            albsol_dir,   albsol_dif,   sens,    evap, snowerosion, &  
                                 !albedo SB <<<
             albsol3_lic,runoff,   snowhgt,   qsnow, to_ice, sissnow, &
             zxtsol,    zxfluxlat, zt2m,    qsat2m,  zn2mout, &
-            d_t_vdf,   d_q_vdf,   d_u_vdf, d_v_vdf, d_t_diss, &
+            d_t_vdf,   d_q_vdf, d_qbs_vdf,  d_u_vdf, d_v_vdf, d_t_diss, &
                                 !nrlmd<
                                 !jyg<
@@ -3067,5 +3178,5 @@
             fluxt,   fluxu,  fluxv, &
             dsens,     devap,     zxsnow, &
-            zxfluxt,   zxfluxq,   q2m,     fluxq, pbl_tke, &
+            zxfluxt,   zxfluxq,  zxfluxqbs,  q2m, fluxq, fluxqbs, pbl_tke, &
                                 !nrlmd+jyg<
             wake_delta_pbl_TKE, &
@@ -3179,5 +3290,5 @@
        IF (klon_glo==1) THEN
           CALL add_pbl_tend &
-               (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,&
+               (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,d_qbs_vdf,paprs,&
                'vdf',abortphy,flag_inhib_tend,itap &
 #ifdef ISO
@@ -3187,5 +3298,5 @@
        ELSE
           CALL add_phys_tend &
-               (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,&
+               (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,d_qbs_vdf,paprs,&
                'vdf',abortphy,flag_inhib_tend,itap,0 &
 #ifdef ISO
@@ -3249,4 +3360,28 @@
 
     ENDIF
+
+    ! ==================================================================
+    ! Blowing snow sublimation and sedimentation
+
+    d_t_bs(:,:)=0.
+    d_q_bs(:,:)=0.
+    d_qbs_bs(:,:)=0.
+    bsfl(:,:)=0.
+    bs_fall(:)=0.
+    IF (ok_bs) THEN
+
+     CALL call_blowing_snow_sublim_sedim(klon,klev,phys_tstep,t_seri,q_seri,qbs_seri,pplay,paprs, &
+                                        d_t_bs,d_q_bs,d_qbs_bs,bsfl,bs_fall)
+
+     CALL add_phys_tend &
+               (du0,dv0,d_t_bs,d_q_bs,dql0,dqi0,d_qbs_bs,paprs,&
+               'bs',abortphy,flag_inhib_tend,itap,0  &
+#ifdef ISO                                       
+       &    ,dxt0,dxtl0,dxti0 &                    
+#endif                                       
+       &   )
+
+    ENDIF
+
     ! =================================================================== c
     !   Calcul de Qsat
@@ -3458,4 +3593,20 @@
                   call iso_verif_egalite(q_w(i,k),xt_w(iso_eau,i,k),'physiq 3338')
                 endif
+                if (iso_HDO.gt.0) then
+                  if ((iso_verif_aberrant_enc_choix_nostop(xt_x(iso_hdo,i,k),q_x(i,k), &
+                        ridicule,deltalim,'physic 3462a xt_x').eq.1).or. &
+                        (iso_verif_aberrant_enc_choix_nostop(xt_w(iso_hdo,i,k),q_w(i,k), &
+                        ridicule,deltalim,'physic 3462b xt_w').eq.1)) then
+                     write(*,*) 'i,k=',i,k
+                     write(*,*) 'q_x(i,k),q_seri(i,k),wake_s(i),wake_deltaq(i,k)=', &
+                                q_x(i,k),q_seri(i,k),wake_s(i),wake_deltaq(i,k)
+                     write(*,*) 'xt_x(iso_hdo,i,k),xt_seri(iso_hdo,i,k),wake_s(i),wake_deltaxt(iso_hdo,i,k)=', &
+                                xt_x(iso_hdo,i,k),xt_seri(iso_hdo,i,k),wake_s(i),wake_deltaxt(iso_hdo,i,k)
+                     write(*,*) 'deltaD_seri,wake=',deltaD(xt_seri(iso_hdo,i,k)/q_seri(i,k)), &
+                                deltaD(wake_deltaxt(iso_hdo,i,k)/wake_deltaq(i,k))
+                     write(*,*) 'deltaD_x,deltaD_w=',deltaD(xt_x(iso_hdo,i,k)/q_x(i,k)),deltaD(xt_w(iso_hdo,i,k)/q_w(i,k))
+                     stop
+                  endif
+                endif
 #endif
 #endif
@@ -3590,5 +3741,5 @@
               call iso_verif_aberrant_encadre( &
      &           xt_w(iso_hdo,i,k)/q_w(i,k), &
-     &          'physic 2657b')
+     &          'physic 2657c')
              endif !if (q_x(i,k).gt.ridicule) then
            endif !if (iso_HDO.gt.0) then
@@ -3671,5 +3822,5 @@
                ALE,ALP, &
                sig1,w01, &
-               d_t_con,d_q_con,d_u_con,d_v_con,d_tr, &
+               d_t_con,d_q_con,fqcomp,d_u_con,d_v_con,d_tr, &
                rain_con, snow_con, ibas_con, itop_con, sigd, &
                ema_cbmf,plcl,plfc,wbeff,convoccur,upwd,dnwd,dnwd0, &
@@ -3682,5 +3833,5 @@
                ftd,fqd,lalim_conv,wght_th, &
                ev, ep,epmlmMm,eplaMm, &
-               wdtrainA, wdtrainS, wdtrainM,wght_cvfd,qtc_cv,sigt_cv, &
+               wdtrainA, wdtrainS, wdtrainM,wght_cvfd,qtc_cv,sigt_cv,detrain_cv, &
                tau_cld_cv,coefw_cld_cv,epmax_diag &
 #ifdef ISO
@@ -3734,4 +3885,5 @@
           clwcon0=qcondc
           pmfu(:,:)=upwd(:,:)+dnwd(:,:)
+          fm_cv(:,:)=upwd(:,:)+dnwd(:,:)+dnwd0(:,:)
           !
           !jyg<
@@ -3920,5 +4072,5 @@
 !!
 !!
-    CALL add_phys_tend(d_u_con, d_v_con, d_t_con, d_q_con, dql0, dqi0, paprs, &
+    CALL add_phys_tend(d_u_con, d_v_con, d_t_con, d_q_con, dql0, dqi0, dqbs0, paprs, &
          'convection',abortphy,flag_inhib_tend,itap,0 &
 #ifdef ISO
@@ -4152,5 +4304,5 @@
        !-----------------------------------------------------------------------
        ! ajout des tendances des poches froides
-       CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,dqi0,paprs,'wake', &
+       CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,dqi0,dqbs0,paprs,'wake', &
             abortphy,flag_inhib_tend,itap,0 &
 #ifdef ISO
@@ -4255,5 +4407,5 @@
              endif !if ((iso_HDO.gt.0).and.(iso_O18.gt.0)) then    
              if ((iso_O17.gt.0).and.(iso_O18.gt.0)) then
-               if ((q_seri(i,k).gt.ridicule).and.(l.lt.nlevmaxO17)) then
+               if ((q_seri(i,k).gt.ridicule).and.(k.lt.nlevmaxO17)) then
                  call iso_verif_aberrant_o17(xt_seri(iso_o17,i,k) &
      &           /q_seri(i,k),xt_seri(iso_o18,i,k) &
@@ -4356,8 +4508,17 @@
 #endif
           !>jyg
+          ! WARNING !!! introduction d'une subtilite avec la distinction
+          ! entre deux types de profiles pour les thermiques.
+          ! Ne change pas les resultats avec les isotopes tant qu'on
+          ! tourne avec le defaut : iflag_thermals_tenv=0
+          if ( iflag_thermals_tenv /= 0 ) then 
+              abort_message ='iflag_thermals_env/=0 : non prevu avec les isotopes'
+              CALL abort_physic (modname,abort_message,1)
+          endif
+
           CALL calltherm(pdtphys &
                ,pplay,paprs,pphi,weak_inversion &
                         ! ,u_seri,v_seri,t_seri,q_seri,zqsat,debut & !jyg
-               ,u_therm,v_therm,t_therm,q_therm,zqsat,debut &  !jyg
+               ,u_therm,v_therm,t_therm,q_therm,t_therm,q_therm,zqsat,debut &  !jyg
                ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs &
                ,fm_therm,entr_therm,detr_therm &
@@ -4431,5 +4592,5 @@
           !
           CALL add_phys_tend(d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs,  &
-                             dql0,dqi0,paprs,'thermals', abortphy,flag_inhib_tend,itap,0 &
+                             dql0,dqi0,dqbs0,paprs,'thermals', abortphy,flag_inhib_tend,itap,0 &
 #ifdef ISO
      &    ,d_xt_ajs,dxtl0,dxti0 &
@@ -4547,5 +4708,5 @@
           !--------------------------------------------------------------------
           ! ajout des tendances de l'ajustement sec ou des thermiques
-          CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,dqi0,paprs, &
+          CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,dqi0,dqbs0,paprs, &
                'ajsb',abortphy,flag_inhib_tend,itap,0 &
 #ifdef ISO
@@ -4582,12 +4743,15 @@
     ENDDO
 
-    CALL  calcratqs(klon,klev,prt_level,lunout,        &
+    CALL ratqs_main(klon,klev,nbsrf,prt_level,lunout,        &
          iflag_ratqs,iflag_con,iflag_cld_th,pdtphys,  &
          ratqsbas,ratqshaut,ratqsp0, ratqsdp, &
+         pctsrf,s_pblh,zstd, &
          tau_ratqs,fact_cldcon,wake_s, wake_deltaq,   &
          ptconv,ptconvth,clwcon0th, rnebcon0th,     &
-         paprs,pplay,t_seri,q_seri, qtc_cv, sigt_cv, zqsat, &
-         pbl_tke(:,:,is_ave),tke_dissip_ave,l_mix_ave,wprime_ave,t2m,q2m,fm_therm, &
-         ratqs,ratqsc,ratqs_inter)
+         paprs,pplay,t_seri,q_seri, &
+         qtc_cv, sigt_cv,detrain_cv,fm_cv,fqd,fqcomp,sigd,zqsat, &
+         omega,pbl_tke(:,:,is_ave),tke_dissip_ave,l_mix_ave,wprime_ave, &
+         t2m,q2m,fm_therm,entr_therm,detr_therm,cell_area, &
+         ratqs,ratqsc,ratqs_inter_)
 
     !
@@ -4619,5 +4783,5 @@
         do i=1,klon
            if ((iso_O17.gt.0).and.(iso_O18.gt.0)) then
-            if ((q_seri(i,k).gt.ridicule).and.(l.lt.nlevmaxO17)) then
+            if ((q_seri(i,k).gt.ridicule).and.(k.lt.nlevmaxO17)) then
              call iso_verif_aberrant_o17(xt_seri(iso_o17,i,k) &
      &           /q_seri(i,k),xt_seri(iso_o18,i,k) &
@@ -4692,11 +4856,14 @@
          t_seri, q_seri,ptconv,ratqs, &
          d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, rneblsvol, rneb_seri, &
-         cldliq, picefra, rain_lsc, snow_lsc, &
+         pfraclr,pfracld, &
+         radocond, picefra, rain_lsc, snow_lsc, &
          frac_impa, frac_nucl, beta_prec_fisrt, &
          prfl, psfl, rhcl,  &
          zqasc, fraca,ztv,zpspsk,ztla,zthl,iflag_cld_th, &
-         iflag_ice_thermo, ok_ice_sursat, zqsatl, zqsats, &
+         iflag_ice_thermo, ok_ice_sursat, zqsatl, zqsats, distcltop, temp_cltop, &
          qclr, qcld, qss, qvc, rnebclr, rnebss, gamma_ss, &
-         Tcontr, qcontr, qcontr2, fcontrN, fcontrP )
+         Tcontr, qcontr, qcontr2, fcontrN, fcontrP , &
+         cloudth_sth,cloudth_senv,cloudth_sigmath,cloudth_sigmaenv)
+
 
     ELSE
@@ -4704,5 +4871,5 @@
     CALL fisrtilp(phys_tstep,paprs,pplay, &
          t_seri, q_seri,ptconv,ratqs, &
-         d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, cldliq, &
+         d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, radocond, &
          rain_lsc, snow_lsc, &
          pfrac_impa, pfrac_nucl, pfrac_1nucl, &
@@ -4752,5 +4919,5 @@
 !    write(*,9000) "rcpv","rcw",rcpv,rcw,rcs,t_seri(1,1)
 !-JLD 
-    CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc,paprs, &
+    CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc,dqbs0,paprs, &
          'lsc',abortphy,flag_inhib_tend,itap,0 &
 #ifdef ISO
